//@Author: Martin Laak.  http://www.arvutilaat.net/D/    Kasutage seda koodi nagu tahate, ainult jtke alles viide minu nimele ja lehele. Use this code however you like, but keep the reference to my name and page,   
//TEEGI std.zip KASUTAMINE, ZIP FAILIDEGA MBERKIMINE

//LIHTNE FAILIDE LAHTIPAKKIJA
//PAKIB LAHTI ZIP FAILI.
//Kasutus myunzip failinime.zip
//Vaadake ka zipsisu.d, see on lihtsam nide:


//NB, ma kasutan siin 'std.file.write(...)' lihtsalt selguse huvides,
//samahsti vib ka lihtsalt 'write(...)'

import std.zip;//klass ZipArchive
import std.file; //Failidega seonduv

ZipArchive ZA; //Peategelane, klass kus sisalduvad kik arhiiviga tegelemise vahendid.
ubyte []cb; //siia loeme hiljem zip faili sisu ja anname ette klassi konstruktorile


//Abifunktsioon. Kui pakitakse lahti arhiivi, kus failid asuvad
//erinevates kataloogides (ja alamkataloogides), siis see funktsioon
//kontrollib nende kataloogide olemasolu ja vajadusel loob nad
//Oluline on ainult, kui nide, kuidas failide ja kataloogidega mber kia.
void makedirs(char [] s){
char []AK;//KAtaloog, kust alustasime, hiljem prdume siia tagasi
char []ss;

AK=std.file.getcwd(); //get current working directory. Kataloog, kus hetkel asume
 VALIMINE:while(1){ //Label 'VALIMINE', ka while ja for directiividele saab labeli panna. Hiljem 'continue VALIMINE' mjutab just seda. Vaadake label.d
  for(int x=0;x<s.length;x++){
   if(s[x]=='/' || s[x]=='\\'){
     ss=s[0..x];     
     //printf("##%.*s##%.*s\n",s,ss);
     if(!std.file.exists(ss))std.file.mkdir(ss); //loome uue kataloogi
     version(linux){
       std.file.chdir(std.file.getcwd()~"/"~ss); //liigume kataloogi puus sgavamale
     }	  
     version(Win32){
       std.file.chdir(std.file.getcwd()~"\\"~ss);
     }
     s=s[x+1..s.length];      
     continue VALIMINE;
   }
  }
  break;
 }
std.file.chdir(AK); //Tagasi sinna kataloogi, kus ennegi olime
}
//////////////////////////////////////////////////////////////





int main(char [][]s){
//kontrollime, et meile anti ikka vhemalt ks sisendparameeter
if(s.length<2){
  version(linux){
    printf("kasutatakse: myunzip failinimi.zip\n");
  } 
  version(Win32){
    printf("kasutatakse: myunzip.exe failinimi.zip\n");
  }
  return 0;
}  
//////////////



try{
  cb=cast(ubyte[])std.file.read(s[1]); //loeme faili sisse
}
catch(FileException e){
  printf("Faili %.*s ei nnestunud avada!\n",s[1]);//kui ei nnestunud, anname veateate
  return 0;
} 

ZA=new ZipArchive(cb);//loome uue zip objecti ja kirjutame zip faili sisu sellesse

foreach(ArchiveMember a;ZA.directory){//vaatame kshaaval lbi kik arhiivis sisalduvad failid. a on ArchiveMember tpi objekt, mis sisaldab faili nime , sisu ja muud informatsiooni. ZA.directory on massiiv (antud juhu assotsiatiivne), mis sisaldab kiki arhiivis olevaid faile.
 printf("pakin lahti: %.*s",a.name); //a.name - faili nimi
 try{
   ubyte []bb=ZA.expand(a); //nii saame ktte faili sisu lahtipakituna
   makedirs(a.name); //kontrollime, et kataloog, kuhu soovime faili paigutada, ikka olemas on.
   if(a.name[a.name.length-1]!='/' && a.name[a.name.length-1]!='\\'){ //faili nimi ei tohi lppeda kaldkriipsuga. Sellisel juhul on tegemist kataloogiga. Kikide vajalike kataloogide tegemise eest vastutab aga juba funktsioon makedirs, nii et nende prast pole meil vaja enam muretseda.
    std.file.write(a.name,bb);
   }
 } 
 catch(Exception e){
  printf(" -- VIGA, ei nnestunud lahti pakkida!"); //millegiprast ei nnestunud faili lahti pakkida  
 } 
 printf("\n");
}
  
return 0;
}